%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%                                                  %     
%   Environmental impacts of Maritime transport    %
%         Programmed 27.05.2013                    %
%                                                  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%Importing data
C = xlsread('Characterisation.xls','StressorOrder','DX15:EO741');
G = xlsread('G.xlsx','G', 'E6:O143');
D = xlsread('D.xlsx','Dkm', 'D8:L16');
G_zeros = zeros(11,138);
Atr_eurtkm = xlsread('Atr.xlsx','Atr_tkm_SCALED', 'E8:O145');
p = xlsread('p.xlsx','p', 'E7:E144');
p_inv = xlsread('p.xlsx','p_inv', 'F7:F144');
S = IO_BG.S;
S_vatrans_eurtkm = xlsread('Atr.xlsx','Atr_tkm_SCALED','E146:O160');
S_va1 = S(1:15,1:138);
S_va2 = S(1:15,1+(138*1):138+(138*1));
S_va3 = S(1:15,1+(138*2):138+(138*2));
S_va4 = S(1:15,1+(138*3):138+(138*3));
S_va5 = S(1:15,1+(138*4):138+(138*4));
S_va6 = S(1:15,1+(138*5):138+(138*5));
S_va7 = S(1:15,1+(138*6):138+(138*6));
S_va8 = S(1:15,1+(138*7):138+(138*7));
S_va9 = S(1:15,1+(138*8):138+(138*8));
S_1 = S(16:727,1:138);
S_2 = S(16:727,1+(138*1):138+(138*1));
S_3 = S(16:727,1+(138*2):138+(138*2));
S_4 = S(16:727,1+(138*3):138+(138*3));
S_5 = S(16:727,1+(138*4):138+(138*4));
S_6 = S(16:727,1+(138*5):138+(138*5));
S_7 = S(16:727,1+(138*6):138+(138*6));
S_8 = S(16:727,1+(138*7):138+(138*7));
S_9 = S(16:727,1+(138*8):138+(138*8));

S_trans = S(16:727,113);
S_trans_tkm = xlsread('S_trans_tkm.xlsx','S_trans_tkm', 'I5:S716'); 
y = IO_BG.y;
y1 = IO_BG.y1;
y_ones = ones(1341,1);
A_orig_big = IO_BG.A;
L = IO_BG.L;
I = eye(1341);
zero = zeros(11,11);
Atr_zero = zeros(138,11);


%% Retrieving A-matrices
for r=1:9
    for s=1:9
        Data(r,s).A = A_orig_big(138*(r-1)+1:138*r,138*(s-1)+1:138*s);
    end
end

%Constructing y-vectors
yreg1 = [y1(1+(138*0):138*1);zeros(11,1)];
yreg2 = [y1(1+(138*1):138*2);zeros(11,1)];
yreg3 = [y1(1+(138*2):138*3);zeros(11,1)];
yreg4 = [y1(1+(138*3):138*4);zeros(11,1)];
yreg5 = [y1(1+(138*4):138*5);zeros(11,1)];
yreg6 = [y1(1+(138*5):138*6);zeros(11,1)];
yreg7 = [y1(1+(138*6):138*7);zeros(11,1)];
yreg8 = [y1(1+(138*7):138*8);zeros(11,1)];
yreg9 = [y1(1+(138*8):138*9);zeros(11,1)];
yreg0 = zeros(149,1);
ymatrix = [yreg1,yreg0,yreg0,yreg0,yreg0,yreg0,yreg0,yreg0,yreg0;yreg0,yreg2,yreg0,yreg0,yreg0,yreg0,yreg0,yreg0,yreg0;yreg0,yreg0,yreg3,yreg0,yreg0,yreg0,yreg0,yreg0,yreg0;yreg0,yreg0,yreg0,yreg4,yreg0,yreg0,yreg0,yreg0,yreg0;yreg0,yreg0,yreg0,yreg0,yreg5,yreg0,yreg0,yreg0,yreg0;yreg0,yreg0,yreg0,yreg0,yreg0,yreg6,yreg0,yreg0,yreg0;yreg0,yreg0,yreg0,yreg0,yreg0,yreg0,yreg7,yreg0,yreg0;yreg0,yreg0,yreg0,yreg0,yreg0,yreg0,yreg0,yreg8,yreg0;yreg0,yreg0,yreg0,yreg0,yreg0,yreg0,yreg0,yreg0,yreg9];

    
%% Calculating G' for each A-matrix
%Step 1
for r=1:9
    for s=1:9
        G_ton(r,s).A = G'*Data(r,s).A;
    end
end
%Step 2
for r = 1:9
    for s = 1:9
        G_toneur(r,s).A = G_ton(r,s).A*diag(p_inv);
    end
end

%% Creating Distance vectors

% Region 1 (China) export distances km
d11 = 0;
d12 = 7037;
d13 = 19446;
d14 = 19631;
d15 = 1852;
d16 = 21298;
d17 = 20372;
d18 = 4630;
d19 = 10371;

% Region 2 (India) Export Distances km
d21 = 7037;
d22 = 0;
d23 = 14445;
d24 = 17223;
d25 = 8334;
d26 = 16297;
d27 = 16297;
d28 = 3889;
d29 = 5370;

% Region 3 (OECD Europe) Export Distances km
d31 = 19446;
d32 = 14445;
d33 = 0; 
d34 = 14445;
d35 = 20742;
d36 = 2037;
d37 = 10186;
d38 = 15927;
d39 = 11667;

% Region 4 (OECD North America)Export Distances km
d41 = 19631;
d42 = 17223;
d43 = 14445; 
d44 = 0;
d45 = 8889;
d46 = 16297;
d47 = 13890;
d48 = 14630;
d49 = 20557;

% Region 5 (OECD Pacific) Export Distances km
d51 = 1852;
d52 = 8334; 
d53 = 20742;
d54 = 8889;
d55 = 0; 
d56 = 22594;
d57 = 21112;
d58 = 5926;
d59 = 11852;

% Region 6 (Economies in Transition) Export Distances km
d61 = 21298;
d62 = 16297;
d63 = 2037;
d64 = 16297;
d65 = 22594;
d66 = 0; 
d67 = 12038;
d68 = 17779;
d69 = 13519;

% Region 7 (Latin America) Export distances km
d71 = 20372; 
d72 = 16297;
d73 = 10186;
d74 = 13890;
d75 = 21112;
d76 = 12038;
d77 = 0;
d78 = 15742;
d79 = 15186;

% Region 8 (Other Developing Asia) Export distances km
d81 = 4630; 
d82 = 3889;
d83 = 15927;
d84 = 14630;
d85 = 5962;
d86 = 17779;
d87 = 15742;
d88 = 0;
d89 = 6852;

% Region 9 (Africa and Middle East) Export distances km
d91 = 10371;
d92 = 5370;
d93 = 11667;
d94 = 20557;
d95 = 11852;
d96 = 13519;
d97 = 15186;
d98 = 6852;
d99 = 0;

%% Constructing new hybrid A matrices 
% Diagonals
A11new = [Data(1,1).A,Atr_eurtkm;G_zeros,zero];
A22new = [Data(2,2).A,Atr_eurtkm;G_zeros,zero];
A33new = [Data(3,3).A,Atr_eurtkm;G_zeros,zero];
A44new = [Data(4,4).A,Atr_eurtkm;G_zeros,zero];
A55new = [Data(5,5).A,Atr_eurtkm;G_zeros,zero];
A66new = [Data(6,6).A,Atr_eurtkm;G_zeros,zero];
A77new = [Data(7,7).A,Atr_eurtkm;G_zeros,zero];
A88new = [Data(8,8).A,Atr_eurtkm;G_zeros,zero];
A99new = [Data(9,9).A,Atr_eurtkm;G_zeros,zero];

% Construction off diagonal A Matrices
% A1,s Matrices
A12new = [Data(1,2).A,Atr_zero;G_toneur(1,2).A*d12,zero];
A13new = [Data(1,3).A,Atr_zero;G_toneur(1,3).A*d13,zero];
A14new = [Data(1,4).A,Atr_zero;G_toneur(1,4).A*d14,zero];
A15new = [Data(1,5).A,Atr_zero;G_toneur(1,5).A*d15,zero];
A16new = [Data(1,6).A,Atr_zero;G_toneur(1,6).A*d16,zero];
A17new = [Data(1,7).A,Atr_zero;G_toneur(1,7).A*d17,zero];
A18new = [Data(1,8).A,Atr_zero;G_toneur(1,8).A*d18,zero];
A19new = [Data(1,9).A,Atr_zero;G_toneur(1,9).A*d19,zero];

% A2,s Matrices

A21new = [Data(2,1).A,Atr_zero;G_toneur(2,1).A*d21,zero];
A23new = [Data(2,3).A,Atr_zero;G_toneur(2,3).A*d23,zero];
A24new = [Data(2,4).A,Atr_zero;G_toneur(2,4).A*d24,zero];
A25new = [Data(2,5).A,Atr_zero;G_toneur(2,5).A*d25,zero];
A26new = [Data(2,6).A,Atr_zero;G_toneur(2,6).A*d26,zero];
A27new = [Data(2,7).A,Atr_zero;G_toneur(2,7).A*d27,zero];
A28new = [Data(2,8).A,Atr_zero;G_toneur(2,8).A*d28,zero];
A29new = [Data(2,9).A,Atr_zero;G_toneur(2,9).A*d29,zero];

% A3,s Matrices

A31new = [Data(3,1).A,Atr_zero;G_toneur(3,1).A*d31,zero];
A32new = [Data(3,2).A,Atr_zero;G_toneur(3,2).A*d32,zero];
A34new = [Data(3,4).A,Atr_zero;G_toneur(3,4).A*d34,zero];
A35new = [Data(3,5).A,Atr_zero;G_toneur(3,5).A*d35,zero];
A36new = [Data(3,6).A,Atr_zero;G_toneur(3,6).A*d36,zero];
A37new = [Data(3,7).A,Atr_zero;G_toneur(3,7).A*d37,zero];
A38new = [Data(3,8).A,Atr_zero;G_toneur(3,8).A*d38,zero];
A39new = [Data(3,9).A,Atr_zero;G_toneur(3,9).A*d39,zero];

% A4,s Matrices

A41new = [Data(4,1).A,Atr_zero;G_toneur(4,1).A*d41,zero];
A42new = [Data(4,2).A,Atr_zero;G_toneur(4,2).A*d42,zero];
A43new = [Data(4,3).A,Atr_zero;G_toneur(4,3).A*d43,zero];
A45new = [Data(4,5).A,Atr_zero;G_toneur(4,5).A*d45,zero];
A46new = [Data(4,6).A,Atr_zero;G_toneur(4,6).A*d46,zero];
A47new = [Data(4,7).A,Atr_zero;G_toneur(4,7).A*d47,zero];
A48new = [Data(4,8).A,Atr_zero;G_toneur(4,8).A*d48,zero];
A49new = [Data(4,9).A,Atr_zero;G_toneur(4,9).A*d49,zero];

% A5,s Matrices

A51new = [Data(5,1).A,Atr_zero;G_toneur(5,1).A*d51,zero];
A52new = [Data(5,2).A,Atr_zero;G_toneur(5,2).A*d52,zero];
A53new = [Data(5,3).A,Atr_zero;G_toneur(5,3).A*d53,zero];
A54new = [Data(5,4).A,Atr_zero;G_toneur(5,4).A*d54,zero];
A56new = [Data(5,6).A,Atr_zero;G_toneur(5,6).A*d56,zero];
A57new = [Data(5,7).A,Atr_zero;G_toneur(5,7).A*d57,zero];
A58new = [Data(5,8).A,Atr_zero;G_toneur(5,8).A*d58,zero];
A59new = [Data(5,9).A,Atr_zero;G_toneur(5,9).A*d59,zero];

% A6,s Matrices

A61new = [Data(6,1).A,Atr_zero;G_toneur(6,1).A*d61,zero];
A62new = [Data(6,2).A,Atr_zero;G_toneur(6,2).A*d62,zero];
A63new = [Data(6,3).A,Atr_zero;G_toneur(6,3).A*d63,zero];
A64new = [Data(6,4).A,Atr_zero;G_toneur(6,4).A*d64,zero];
A65new = [Data(6,5).A,Atr_zero;G_toneur(6,5).A*d65,zero];
A67new = [Data(6,7).A,Atr_zero;G_toneur(6,7).A*d67,zero];
A68new = [Data(6,8).A,Atr_zero;G_toneur(6,8).A*d68,zero];
A69new = [Data(6,9).A,Atr_zero;G_toneur(6,9).A*d69,zero];

% A7,s Matrices

A71new = [Data(7,1).A,Atr_zero;G_toneur(7,1).A*d71,zero];
A72new = [Data(7,2).A,Atr_zero;G_toneur(7,2).A*d72,zero];
A73new = [Data(7,3).A,Atr_zero;G_toneur(7,3).A*d73,zero];
A74new = [Data(7,4).A,Atr_zero;G_toneur(7,4).A*d74,zero];
A75new = [Data(7,5).A,Atr_zero;G_toneur(7,5).A*d75,zero];
A76new = [Data(7,6).A,Atr_zero;G_toneur(7,6).A*d76,zero];
A78new = [Data(7,8).A,Atr_zero;G_toneur(7,8).A*d78,zero];
A79new = [Data(7,9).A,Atr_zero;G_toneur(7,9).A*d79,zero];

% A8,s Matrices

A81new = [Data(8,1).A,Atr_zero;G_toneur(8,1).A*d81,zero];
A82new = [Data(8,2).A,Atr_zero;G_toneur(8,2).A*d82,zero];
A83new = [Data(8,3).A,Atr_zero;G_toneur(8,3).A*d83,zero];
A84new = [Data(8,4).A,Atr_zero;G_toneur(8,4).A*d84,zero];
A85new = [Data(8,5).A,Atr_zero;G_toneur(8,5).A*d85,zero];
A86new = [Data(8,6).A,Atr_zero;G_toneur(8,6).A*d86,zero];
A87new = [Data(8,7).A,Atr_zero;G_toneur(8,7).A*d87,zero];
A89new = [Data(8,9).A,Atr_zero;G_toneur(8,9).A*d89,zero];

% A9,s Matrices

A91new = [Data(9,1).A,Atr_zero;G_toneur(9,1).A*d91,zero];
A92new = [Data(9,2).A,Atr_zero;G_toneur(9,2).A*d92,zero];
A93new = [Data(9,3).A,Atr_zero;G_toneur(9,3).A*d93,zero];
A94new = [Data(9,4).A,Atr_zero;G_toneur(9,4).A*d94,zero];
A95new = [Data(9,5).A,Atr_zero;G_toneur(9,5).A*d95,zero];
A96new = [Data(9,6).A,Atr_zero;G_toneur(9,6).A*d96,zero];
A97new = [Data(9,7).A,Atr_zero;G_toneur(9,7).A*d97,zero];
A98new = [Data(9,8).A,Atr_zero;G_toneur(9,8).A*d98,zero];

%% Construction new big A matrix

% step1
Anew_ve_1 = [A11new,A12new,A13new,A14new,A15new,A16new,A17new,A18new,A19new];
Anew_ve_2 = [A21new,A22new,A23new,A24new,A25new,A26new,A27new,A28new,A29new];
Anew_ve_3 = [A31new,A32new,A33new,A34new,A35new,A36new,A37new,A38new,A39new];
Anew_ve_4 = [A41new,A42new,A43new,A44new,A45new,A46new,A47new,A48new,A49new];
Anew_ve_5 = [A51new,A52new,A53new,A54new,A55new,A56new,A57new,A58new,A59new];
Anew_ve_6 = [A61new,A62new,A63new,A64new,A65new,A66new,A67new,A68new,A69new];
Anew_ve_7 = [A71new,A72new,A73new,A74new,A75new,A76new,A77new,A78new,A79new];
Anew_ve_8 = [A81new,A82new,A83new,A84new,A85new,A86new,A87new,A88new,A89new];
Anew_ve_9 = [A91new,A92new,A93new,A94new,A95new,A96new,A97new,A98new,A99new];

%step 2

Anew_big = [Anew_ve_1;Anew_ve_2;Anew_ve_3;Anew_ve_4;Anew_ve_5;Anew_ve_6;Anew_ve_7;Anew_ve_8;Anew_ve_9];

%% Construction of new Value added

S_va_new = [S_va1,S_vatrans_eurtkm,S_va2,S_vatrans_eurtkm,S_va3,S_vatrans_eurtkm,S_va4,S_vatrans_eurtkm,S_va5,S_vatrans_eurtkm,S_va6,S_vatrans_eurtkm,S_va7,S_vatrans_eurtkm,S_va8,S_vatrans_eurtkm,S_va9,S_vatrans_eurtkm];

%% Constructing new S_trans

S_trans_new = [S_1,S_trans_tkm,S_2,S_trans_tkm,S_3,S_trans_tkm,S_4,S_trans_tkm,S_5,S_trans_tkm,S_6,S_trans_tkm,S_7,S_trans_tkm,S_8,S_trans_tkm,S_9,S_trans_tkm];

%% Constructing S_new
S_new = [S_va_new;S_trans_new];

%% Constructing S with only stressors
S_str = S_new(15+18+1:727,1:1341);
%xlswrite('S_trans_tkm.xlsx',S_trans,'S_trans_vector','D5');



%% MODEL CALCULATIONS

xma = (I-Anew_big)^-1*ymatrix;
xshipping_reg1 = xshipping_total(1+(11*0):11+(11*0),1:9);
xshipping_reg2 = xshipping_total(1+(11*1):11+(11*1),1:9);
xshipping_reg3 = xshipping_total(1+(11*2):11+(11*2),1:9);
xshipping_reg4 = xshipping_total(1+(11*3):11+(11*3),1:9);
xshipping_reg5 = xshipping_total(1+(11*4):11+(11*4),1:9);
xshipping_reg6 = xshipping_total(1+(11*5):11+(11*5),1:9);
xshipping_reg7 = xshipping_total(1+(11*6):11+(11*6),1:9);
xshipping_reg8 = xshipping_total(1+(11*7):11+(11*7),1:9);
xshipping_reg9 = xshipping_total(1+(11*8):11+(11*8),1:9);

x = sum(xma,2);

xshipping_total = xlsread('RESULTS.xlsx','xshipping','D5:L103'); 

%% Z-matrix

Z = Anew_big*(diag(x));

for r=1:9
    for s=1:9
        zdata(r,s).Z = Z(149*(r-1)+1:149*(r-1)+138,149*(s-1)+1:149*(s-1)+138);
    end
end

for r=1:9
    for s=1:9
        Zdata_sum(r,s).Zsum = sum(sum(zdata(r,s).Z,2),1);
    end
end

for r=1:9
    for s=1:9
        Gz(r,s).Gz = G'*zdata(r,s).Z;
    end
end

for r=1:9
    for s=1:9
        Gz_sum(r,s).Gz_sum = sum(Gz(r,s).Gz,2);
    end
end

for r=1:9
    for s=1:9
        Gz_tkm(r,s).Gz_tkm = Z(149*(r-1)+139:149*r,149*(s-1)+1:149*(s-1)+138);
    end
end

for r=1:9
    for s=1:9
        Gz_tkm_sum(r,s).Gz_tkm_sum = sum(Gz_tkm(r,s).Gz_tkm,2);
    end
end



      

%% Sum flows between regions

% Region 1 - China
Zsum11 = Zdata_sum(1,1).Zsum;
Zsum12 = Zdata_sum(1,2).Zsum;
Zsum13 = Zdata_sum(1,3).Zsum;
Zsum14 = Zdata_sum(1,4).Zsum;
Zsum15 = Zdata_sum(1,5).Zsum;
Zsum16 = Zdata_sum(1,6).Zsum;
Zsum17 = Zdata_sum(1,7).Zsum;
Zsum18 = Zdata_sum(1,8).Zsum;
Zsum19 = Zdata_sum(1,9).Zsum;

% Region 2 - India
Zsum21 = Zdata_sum(2,1).Zsum;
Zsum22 = Zdata_sum(2,2).Zsum;
Zsum23 = Zdata_sum(2,3).Zsum;
Zsum24 = Zdata_sum(2,4).Zsum;
Zsum25 = Zdata_sum(2,5).Zsum;
Zsum26 = Zdata_sum(2,6).Zsum;
Zsum27 = Zdata_sum(2,7).Zsum;
Zsum28 = Zdata_sum(2,8).Zsum;
Zsum29 = Zdata_sum(2,9).Zsum;

% Region 3 - OECD Europe
Zsum31 = Zdata_sum(3,1).Zsum;
Zsum32 = Zdata_sum(3,2).Zsum;
Zsum33 = Zdata_sum(3,3).Zsum;
Zsum34 = Zdata_sum(3,4).Zsum;
Zsum35 = Zdata_sum(3,5).Zsum;
Zsum36 = Zdata_sum(3,6).Zsum;
Zsum37 = Zdata_sum(3,7).Zsum;
Zsum38 = Zdata_sum(3,8).Zsum;
Zsum39 = Zdata_sum(3,9).Zsum;

% Region 4 - North America
Zsum41 = Zdata_sum(4,1).Zsum;
Zsum42 = Zdata_sum(4,2).Zsum;
Zsum43 = Zdata_sum(4,3).Zsum;
Zsum44 = Zdata_sum(4,4).Zsum;
Zsum45 = Zdata_sum(4,5).Zsum;
Zsum46 = Zdata_sum(4,6).Zsum;
Zsum47 = Zdata_sum(4,7).Zsum;
Zsum48 = Zdata_sum(4,8).Zsum;
Zsum49 = Zdata_sum(4,9).Zsum;

% Region 5 - OECD Pacific
Zsum51 = Zdata_sum(5,1).Zsum;
Zsum52 = Zdata_sum(5,2).Zsum;
Zsum53 = Zdata_sum(5,3).Zsum;
Zsum54 = Zdata_sum(5,4).Zsum;
Zsum55 = Zdata_sum(5,5).Zsum;
Zsum56 = Zdata_sum(5,6).Zsum;
Zsum57 = Zdata_sum(5,7).Zsum;
Zsum58 = Zdata_sum(5,8).Zsum;
Zsum59 = Zdata_sum(5,9).Zsum;

% Region 6 - EIT
Zsum61 = Zdata_sum(6,1).Zsum;
Zsum62 = Zdata_sum(6,2).Zsum;
Zsum63 = Zdata_sum(6,3).Zsum;
Zsum64 = Zdata_sum(6,4).Zsum;
Zsum65 = Zdata_sum(6,5).Zsum;
Zsum66 = Zdata_sum(6,6).Zsum;
Zsum67 = Zdata_sum(6,7).Zsum;
Zsum68 = Zdata_sum(6,8).Zsum;
Zsum69 = Zdata_sum(6,9).Zsum;

% Region 7 - LA
Zsum71 = Zdata_sum(7,1).Zsum;
Zsum72 = Zdata_sum(7,2).Zsum;
Zsum73 = Zdata_sum(7,3).Zsum;
Zsum74 = Zdata_sum(7,4).Zsum;
Zsum75 = Zdata_sum(7,5).Zsum;
Zsum76 = Zdata_sum(7,6).Zsum;
Zsum77 = Zdata_sum(7,7).Zsum;
Zsum78 = Zdata_sum(7,8).Zsum;
Zsum79 = Zdata_sum(7,9).Zsum;

% Region 8 - AS
Zsum81 = Zdata_sum(8,1).Zsum;
Zsum82 = Zdata_sum(8,2).Zsum;
Zsum83 = Zdata_sum(8,3).Zsum;
Zsum84 = Zdata_sum(8,4).Zsum;
Zsum85 = Zdata_sum(8,5).Zsum;
Zsum86 = Zdata_sum(8,6).Zsum;
Zsum87 = Zdata_sum(8,7).Zsum;
Zsum88 = Zdata_sum(8,8).Zsum;
Zsum89 = Zdata_sum(8,9).Zsum;

% Region 9 - AME
Zsum91 = Zdata_sum(9,1).Zsum;
Zsum92 = Zdata_sum(9,2).Zsum;
Zsum93 = Zdata_sum(9,3).Zsum;
Zsum94 = Zdata_sum(9,4).Zsum;
Zsum95 = Zdata_sum(9,5).Zsum;
Zsum96 = Zdata_sum(9,6).Zsum;
Zsum97 = Zdata_sum(9,7).Zsum;
Zsum98 = Zdata_sum(9,8).Zsum;
Zsum99 = Zdata_sum(9,9).Zsum;

% Construction Zsum matrix

Zsum = [Zsum11,Zsum12,Zsum13,Zsum14,Zsum15,Zsum16,Zsum17,Zsum18,Zsum19;Zsum21,Zsum22,Zsum23,Zsum24,Zsum25,Zsum26,Zsum27,Zsum28,Zsum29;Zsum31,Zsum32,Zsum33,Zsum34,Zsum35,Zsum36,Zsum37,Zsum38,Zsum39;Zsum41,Zsum42,Zsum43,Zsum44,Zsum45,Zsum46,Zsum47,Zsum48,Zsum49;Zsum51,Zsum52,Zsum53,Zsum54,Zsum55,Zsum56,Zsum57,Zsum58,Zsum59;Zsum61,Zsum62,Zsum63,Zsum64,Zsum65,Zsum66,Zsum67,Zsum68,Zsum69;Zsum71,Zsum72,Zsum73,Zsum74,Zsum75,Zsum76,Zsum77,Zsum78,Zsum79;Zsum81,Zsum82,Zsum83,Zsum84,Zsum85,Zsum86,Zsum87,Zsum88,Zsum89;Zsum91,Zsum92,Zsum93,Zsum94,Zsum95,Zsum96,Zsum97,Zsum98,Zsum99];



%% Constructing Gz_sum matrix
% monetary flows of transportation from region r to region s

% Region 1 - China
Gz_sum11 = zeros(11,1);
Gz_sum12 = Gz_sum(1,2).Gz_sum;
Gz_sum13 = Gz_sum(1,3).Gz_sum;
Gz_sum14 = Gz_sum(1,4).Gz_sum;
Gz_sum15 = Gz_sum(1,5).Gz_sum;
Gz_sum16 = Gz_sum(1,6).Gz_sum;
Gz_sum17 = Gz_sum(1,7).Gz_sum;
Gz_sum18 = Gz_sum(1,8).Gz_sum;
Gz_sum19 = Gz_sum(1,9).Gz_sum;

%Region 2 - India
Gz_sum21 = Gz_sum(2,1).Gz_sum;
Gz_sum22 = zeros(11,1);
Gz_sum23 = Gz_sum(2,3).Gz_sum;
Gz_sum24 = Gz_sum(2,4).Gz_sum;
Gz_sum25 = Gz_sum(2,5).Gz_sum;
Gz_sum26 = Gz_sum(2,6).Gz_sum;
Gz_sum27 = Gz_sum(2,7).Gz_sum;
Gz_sum28 = Gz_sum(2,8).Gz_sum;
Gz_sum29 = Gz_sum(2,9).Gz_sum;

%Region 3 - OECD Europe
Gz_sum31 = Gz_sum(3,1).Gz_sum;
Gz_sum32 = Gz_sum(3,2).Gz_sum;
Gz_sum33 = zeros(11,1);
Gz_sum34 = Gz_sum(3,4).Gz_sum;
Gz_sum35 = Gz_sum(3,5).Gz_sum;
Gz_sum36 = Gz_sum(3,6).Gz_sum;
Gz_sum37 = Gz_sum(3,7).Gz_sum;
Gz_sum38 = Gz_sum(3,8).Gz_sum;
Gz_sum39 = Gz_sum(3,9).Gz_sum;

%Region 4 - North America
Gz_sum41 = Gz_sum(4,1).Gz_sum;
Gz_sum42 = Gz_sum(4,2).Gz_sum;
Gz_sum43 = Gz_sum(4,3).Gz_sum;
Gz_sum44 = zeros(11,1);
Gz_sum45 = Gz_sum(4,5).Gz_sum;
Gz_sum46 = Gz_sum(4,6).Gz_sum;
Gz_sum47 = Gz_sum(4,7).Gz_sum;
Gz_sum48 = Gz_sum(4,8).Gz_sum;
Gz_sum49 = Gz_sum(4,9).Gz_sum;

%Region 5 - OECD Pacific
Gz_sum51 = Gz_sum(5,1).Gz_sum;
Gz_sum52 = Gz_sum(5,2).Gz_sum;
Gz_sum53 = Gz_sum(5,3).Gz_sum;
Gz_sum54 = Gz_sum(5,4).Gz_sum;
Gz_sum55 = zeros(11,1);
Gz_sum56 = Gz_sum(5,6).Gz_sum;
Gz_sum57 = Gz_sum(5,7).Gz_sum;
Gz_sum58 = Gz_sum(5,8).Gz_sum;
Gz_sum59 = Gz_sum(5,9).Gz_sum;

% Region 6 - Economies in transition
Gz_sum61 = Gz_sum(6,1).Gz_sum;
Gz_sum62 = Gz_sum(6,2).Gz_sum;
Gz_sum63 = Gz_sum(6,3).Gz_sum;
Gz_sum64 = Gz_sum(6,4).Gz_sum;
Gz_sum65 = Gz_sum(6,5).Gz_sum;
Gz_sum66 = zeros(11,1);
Gz_sum67 = Gz_sum(6,7).Gz_sum;
Gz_sum68 = Gz_sum(6,8).Gz_sum;
Gz_sum69 = Gz_sum(6,9).Gz_sum;

%Region 7 - Latin America
Gz_sum71 = Gz_sum(7,1).Gz_sum;
Gz_sum72 = Gz_sum(7,2).Gz_sum;
Gz_sum73 = Gz_sum(7,3).Gz_sum;
Gz_sum74 = Gz_sum(7,4).Gz_sum;
Gz_sum75 = Gz_sum(7,5).Gz_sum;
Gz_sum76 = Gz_sum(7,6).Gz_sum;
Gz_sum77 = zeros(11,1);
Gz_sum78 = Gz_sum(7,8).Gz_sum;
Gz_sum79 = Gz_sum(7,9).Gz_sum;

%Region 8 - Other Developing Asia
Gz_sum81 = Gz_sum(8,1).Gz_sum;
Gz_sum82 = Gz_sum(8,2).Gz_sum;
Gz_sum83 = Gz_sum(8,3).Gz_sum;
Gz_sum84 = Gz_sum(8,4).Gz_sum;
Gz_sum85 = Gz_sum(8,5).Gz_sum;
Gz_sum86 = Gz_sum(8,6).Gz_sum;
Gz_sum87 = Gz_sum(8,7).Gz_sum;
Gz_sum88 = zeros(11,1);
Gz_sum89 = Gz_sum(8,9).Gz_sum;

%Region 9 - Africa and the Middle East
Gz_sum91 = Gz_sum(9,1).Gz_sum;
Gz_sum92 = Gz_sum(9,2).Gz_sum;
Gz_sum93 = Gz_sum(9,3).Gz_sum;
Gz_sum94 = Gz_sum(9,4).Gz_sum;
Gz_sum95 = Gz_sum(9,5).Gz_sum;
Gz_sum96 = Gz_sum(9,6).Gz_sum;
Gz_sum97 = Gz_sum(9,7).Gz_sum;
Gz_sum98 = Gz_sum(9,8).Gz_sum;
Gz_sum99 = zeros(11,1);

Gz_sum_matrix = [Gz_sum11,Gz_sum12,Gz_sum13,Gz_sum14,Gz_sum15,Gz_sum16,Gz_sum17,Gz_sum18,Gz_sum19;Gz_sum21,Gz_sum22,Gz_sum23,Gz_sum24,Gz_sum25,Gz_sum26,Gz_sum27,Gz_sum28,Gz_sum29;Gz_sum31,Gz_sum32,Gz_sum33,Gz_sum34,Gz_sum35,Gz_sum36,Gz_sum37,Gz_sum38,Gz_sum39;Gz_sum41,Gz_sum42,Gz_sum43,Gz_sum44,Gz_sum45,Gz_sum46,Gz_sum47,Gz_sum48,Gz_sum49;Gz_sum51,Gz_sum52,Gz_sum53,Gz_sum54,Gz_sum55,Gz_sum56,Gz_sum57,Gz_sum58,Gz_sum59;Gz_sum61,Gz_sum62,Gz_sum63,Gz_sum64,Gz_sum65,Gz_sum66,Gz_sum67,Gz_sum68,Gz_sum69;Gz_sum71,Gz_sum72,Gz_sum73,Gz_sum74,Gz_sum75,Gz_sum76,Gz_sum77,Gz_sum78,Gz_sum79;Gz_sum81,Gz_sum82,Gz_sum83,Gz_sum84,Gz_sum85,Gz_sum86,Gz_sum87,Gz_sum88,Gz_sum89;Gz_sum91,Gz_sum92,Gz_sum93,Gz_sum94,Gz_sum95,Gz_sum96,Gz_sum97,Gz_sum98,Gz_sum99];

%% Constructing Gz_tkm_sum matrix
% Amount of ton km pr vessel from region r to region s

%Region 1 - China
Gz_tkmsum11 = Gz_tkm_sum(1,1).Gz_tkm_sum;
Gz_tkmsum12 = Gz_tkm_sum(1,2).Gz_tkm_sum;
Gz_tkmsum13 = Gz_tkm_sum(1,3).Gz_tkm_sum;
Gz_tkmsum14 = Gz_tkm_sum(1,4).Gz_tkm_sum;
Gz_tkmsum15 = Gz_tkm_sum(1,5).Gz_tkm_sum;
Gz_tkmsum16 = Gz_tkm_sum(1,6).Gz_tkm_sum;
Gz_tkmsum17 = Gz_tkm_sum(1,7).Gz_tkm_sum;
Gz_tkmsum18 = Gz_tkm_sum(1,8).Gz_tkm_sum;
Gz_tkmsum19 = Gz_tkm_sum(1,9).Gz_tkm_sum;

%Region 2 - India
Gz_tkmsum21 = Gz_tkm_sum(2,1).Gz_tkm_sum;
Gz_tkmsum22 = Gz_tkm_sum(2,2).Gz_tkm_sum;
Gz_tkmsum23 = Gz_tkm_sum(2,3).Gz_tkm_sum;
Gz_tkmsum24 = Gz_tkm_sum(2,4).Gz_tkm_sum;
Gz_tkmsum25 = Gz_tkm_sum(2,5).Gz_tkm_sum;
Gz_tkmsum26 = Gz_tkm_sum(2,6).Gz_tkm_sum;
Gz_tkmsum27 = Gz_tkm_sum(2,7).Gz_tkm_sum;
Gz_tkmsum28 = Gz_tkm_sum(2,8).Gz_tkm_sum;
Gz_tkmsum29 = Gz_tkm_sum(2,9).Gz_tkm_sum;

%Region 3 - OECD Europe
Gz_tkmsum31 = Gz_tkm_sum(3,1).Gz_tkm_sum;
Gz_tkmsum32 = Gz_tkm_sum(3,2).Gz_tkm_sum;
Gz_tkmsum33 = Gz_tkm_sum(3,3).Gz_tkm_sum;
Gz_tkmsum34 = Gz_tkm_sum(3,4).Gz_tkm_sum;
Gz_tkmsum35 = Gz_tkm_sum(3,5).Gz_tkm_sum;
Gz_tkmsum36 = Gz_tkm_sum(3,6).Gz_tkm_sum;
Gz_tkmsum37 = Gz_tkm_sum(3,7).Gz_tkm_sum;
Gz_tkmsum38 = Gz_tkm_sum(3,8).Gz_tkm_sum;
Gz_tkmsum39 = Gz_tkm_sum(3,9).Gz_tkm_sum;

%Region 4 - North America
Gz_tkmsum41 = Gz_tkm_sum(4,1).Gz_tkm_sum;
Gz_tkmsum42 = Gz_tkm_sum(4,2).Gz_tkm_sum;
Gz_tkmsum43 = Gz_tkm_sum(4,3).Gz_tkm_sum;
Gz_tkmsum44 = Gz_tkm_sum(4,4).Gz_tkm_sum;
Gz_tkmsum45 = Gz_tkm_sum(4,5).Gz_tkm_sum;
Gz_tkmsum46 = Gz_tkm_sum(4,6).Gz_tkm_sum;
Gz_tkmsum47 = Gz_tkm_sum(4,7).Gz_tkm_sum;
Gz_tkmsum48 = Gz_tkm_sum(4,8).Gz_tkm_sum;
Gz_tkmsum49 = Gz_tkm_sum(4,9).Gz_tkm_sum;

%Region 5 - OECD Pacific
Gz_tkmsum51 = Gz_tkm_sum(5,1).Gz_tkm_sum;
Gz_tkmsum52 = Gz_tkm_sum(5,2).Gz_tkm_sum;
Gz_tkmsum53 = Gz_tkm_sum(5,3).Gz_tkm_sum;
Gz_tkmsum54 = Gz_tkm_sum(5,4).Gz_tkm_sum;
Gz_tkmsum55 = Gz_tkm_sum(5,5).Gz_tkm_sum;
Gz_tkmsum56 = Gz_tkm_sum(5,6).Gz_tkm_sum;
Gz_tkmsum57 = Gz_tkm_sum(5,7).Gz_tkm_sum;
Gz_tkmsum58 = Gz_tkm_sum(5,8).Gz_tkm_sum;
Gz_tkmsum59 = Gz_tkm_sum(5,9).Gz_tkm_sum;

%Region 6 - EIT
Gz_tkmsum61 = Gz_tkm_sum(6,1).Gz_tkm_sum;
Gz_tkmsum62 = Gz_tkm_sum(6,2).Gz_tkm_sum;
Gz_tkmsum63 = Gz_tkm_sum(6,3).Gz_tkm_sum;
Gz_tkmsum64 = Gz_tkm_sum(6,4).Gz_tkm_sum;
Gz_tkmsum65 = Gz_tkm_sum(6,5).Gz_tkm_sum;
Gz_tkmsum66 = Gz_tkm_sum(6,6).Gz_tkm_sum;
Gz_tkmsum67 = Gz_tkm_sum(6,7).Gz_tkm_sum;
Gz_tkmsum68 = Gz_tkm_sum(6,8).Gz_tkm_sum;
Gz_tkmsum69 = Gz_tkm_sum(6,9).Gz_tkm_sum;

%Region 7 - LA
Gz_tkmsum71 = Gz_tkm_sum(7,1).Gz_tkm_sum;
Gz_tkmsum72 = Gz_tkm_sum(7,2).Gz_tkm_sum;
Gz_tkmsum73 = Gz_tkm_sum(7,3).Gz_tkm_sum;
Gz_tkmsum74 = Gz_tkm_sum(7,4).Gz_tkm_sum;
Gz_tkmsum75 = Gz_tkm_sum(7,5).Gz_tkm_sum;
Gz_tkmsum76 = Gz_tkm_sum(7,6).Gz_tkm_sum;
Gz_tkmsum77 = Gz_tkm_sum(7,7).Gz_tkm_sum;
Gz_tkmsum78 = Gz_tkm_sum(7,8).Gz_tkm_sum;
Gz_tkmsum79 = Gz_tkm_sum(7,9).Gz_tkm_sum;

%Region 8 - AS
Gz_tkmsum81 = Gz_tkm_sum(8,1).Gz_tkm_sum;
Gz_tkmsum82 = Gz_tkm_sum(8,2).Gz_tkm_sum;
Gz_tkmsum83 = Gz_tkm_sum(8,3).Gz_tkm_sum;
Gz_tkmsum84 = Gz_tkm_sum(8,4).Gz_tkm_sum;
Gz_tkmsum85 = Gz_tkm_sum(8,5).Gz_tkm_sum;
Gz_tkmsum86 = Gz_tkm_sum(8,6).Gz_tkm_sum;
Gz_tkmsum87 = Gz_tkm_sum(8,7).Gz_tkm_sum;
Gz_tkmsum88 = Gz_tkm_sum(8,8).Gz_tkm_sum;
Gz_tkmsum89 = Gz_tkm_sum(8,9).Gz_tkm_sum;

%Region 9 - AME
Gz_tkmsum91 = Gz_tkm_sum(9,1).Gz_tkm_sum;
Gz_tkmsum92 = Gz_tkm_sum(9,2).Gz_tkm_sum;
Gz_tkmsum93 = Gz_tkm_sum(9,3).Gz_tkm_sum;
Gz_tkmsum94 = Gz_tkm_sum(9,4).Gz_tkm_sum;
Gz_tkmsum95 = Gz_tkm_sum(9,5).Gz_tkm_sum;
Gz_tkmsum96 = Gz_tkm_sum(9,6).Gz_tkm_sum;
Gz_tkmsum97 = Gz_tkm_sum(9,7).Gz_tkm_sum;
Gz_tkmsum98 = Gz_tkm_sum(9,8).Gz_tkm_sum;
Gz_tkmsum99 = Gz_tkm_sum(9,9).Gz_tkm_sum;

Gz_tkmsum1 = [Gz_tkmsum11,Gz_tkmsum12,Gz_tkmsum13,Gz_tkmsum14,Gz_tkmsum15,Gz_tkmsum16,Gz_tkmsum17,Gz_tkmsum18,Gz_tkmsum19];
Gz_tkmsum2 = [Gz_tkmsum21,Gz_tkmsum22,Gz_tkmsum23,Gz_tkmsum24,Gz_tkmsum25,Gz_tkmsum26,Gz_tkmsum27,Gz_tkmsum28,Gz_tkmsum29];
Gz_tkmsum3 = [Gz_tkmsum31,Gz_tkmsum32,Gz_tkmsum33,Gz_tkmsum34,Gz_tkmsum35,Gz_tkmsum36,Gz_tkmsum37,Gz_tkmsum38,Gz_tkmsum39];
Gz_tkmsum4 = [Gz_tkmsum41,Gz_tkmsum42,Gz_tkmsum43,Gz_tkmsum44,Gz_tkmsum45,Gz_tkmsum46,Gz_tkmsum47,Gz_tkmsum48,Gz_tkmsum49];
Gz_tkmsum5 = [Gz_tkmsum51,Gz_tkmsum52,Gz_tkmsum53,Gz_tkmsum54,Gz_tkmsum55,Gz_tkmsum56,Gz_tkmsum57,Gz_tkmsum58,Gz_tkmsum59];
Gz_tkmsum6 = [Gz_tkmsum61,Gz_tkmsum62,Gz_tkmsum63,Gz_tkmsum64,Gz_tkmsum65,Gz_tkmsum66,Gz_tkmsum67,Gz_tkmsum68,Gz_tkmsum69];
Gz_tkmsum7 = [Gz_tkmsum71,Gz_tkmsum72,Gz_tkmsum73,Gz_tkmsum74,Gz_tkmsum75,Gz_tkmsum76,Gz_tkmsum77,Gz_tkmsum78,Gz_tkmsum79];
Gz_tkmsum8 = [Gz_tkmsum81,Gz_tkmsum82,Gz_tkmsum83,Gz_tkmsum84,Gz_tkmsum85,Gz_tkmsum86,Gz_tkmsum87,Gz_tkmsum88,Gz_tkmsum89];
Gz_tkmsum9 = [Gz_tkmsum91,Gz_tkmsum92,Gz_tkmsum93,Gz_tkmsum94,Gz_tkmsum95,Gz_tkmsum96,Gz_tkmsum97,Gz_tkmsum98,Gz_tkmsum99];

Gz_tkm_sum_matrix = [Gz_tkmsum1;Gz_tkmsum2;Gz_tkmsum3;Gz_tkmsum4;Gz_tkmsum5;Gz_tkmsum6;Gz_tkmsum7;Gz_tkmsum8;Gz_tkmsum9];




%xlswrite('RESULTS.xlsx',xma,'xma','D4');
%xlswrite('RESULTS.xlsx',Gz_sum_matrix,'Gz_sum','F10');
%xlswrite('RESULTS.xlsx',Zsum,'Zsum','D5');
%xlswrite('RESULTS.xlsx',Gz_tkm_sum_matrix,'G_tkm','D5');

%% Calculating env impacts

for r=1:9
    e(:,:,r) = S_new*diag(xma(:,r));
    for s=1:9        
        e_total_shipping(:,11*(s-1)+1:11*s,r) = e(:,149*(s-1)+139:149*s,r);
        e_agg_shipping(:,s,r) = sum(e(:,(149*(s-1)+139:149*s),r),2);
        e_agg(:,s,r) = sum(e(:,(149*(s-1)+1:149*s),r),2);
        
        d_total_shipping(:,11*(s-1)+1:11*s,r) = C'*e_total_shipping(:,11*(s-1)+1:11*s,r);
        d_agg_shipping(:,s,r) = C'*e_agg_shipping(:,s,r);
        d_agg(:,s,r) = C'*e_agg(:,s,r);
    end
end
%% Constructing aggregated shipping emissions from each region
ss
d_gwp_total_shipping = squeeze(d_total_shipping(2,:,:));
d_gwp_agg_shipping = squeeze(d_agg_shipping(2,:,:));
d_gwp_agg = squeeze(d_agg(2,:,:));

xlswrite('RESULTS_envimp.xlsx',d_gwp_total_shipping,'d_gwp_total_shipping','E4');
xlswrite('RESULTS_envimp.xlsx',d_gwp_agg_shipping,'d_gwp_agg_shipping','C9');
xlswrite('RESULTS_envimp.xlsx',d_gwp_agg,'d_gwp_agg','C7');

shipping_shares = e_agg_shipping./e_agg;
shipping_shares_imp = d_agg_shipping./d_agg;

shipping_shares(isnan(shipping_shares))=0;
shipping_shares(isinf(shipping_shares))=0;















             
                
            



